/* REXX Program used to set up an office machine as a PPP server */
/* This program uses the netstat utility to get the local ethernet address and IP address */
/* Then it executes an arp and starts PPP in silent mode */
/* The user must enter the parameters on the first 3 lines */

/* Written by Phil West, GTRI October 1995                                  */
/* Copyright (c) 1995 by Phil West and the Georgia Tech Research Institute  */


remote_ip = 123.123.123.123
com_port = "com3"   /* your modem com port (no colon, lowercase, within quotes)*/
my_netmask = 255.255.255.0


call RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
call SysLoadFuncs


/* First get the physical address */
'@netstat -n | rxqueue'
Do While Queued() > 0
   Pull Line
   if pos('PHYSICAL ADDRESS',line)\=0 then
       parse var line junk1 junk2  phys_address junk3
   else
     iterate
end


/* Next, get the IP address */
'@netstat -a | rxqueue'
Do While Queued() > 0
   Pull Line
   if pos('ADDR',line)\=0 then
       parse var line junk1 local_ip junk2
   else
     iterate
end

say 'The physical address is' phys_address 'the IP address is' local_ip
new_phys_address=substr(phys_address,1,2)
do i= 1 to 5
  new_phys_address=new_phys_address||':'||substr(phys_address,2*i+1,2)
end
say new_phys_address

/*arp '-f'*/                                                        /* flush all current routes, including needed ones... */
arp '-s' remote_ip new_phys_address 'pub'

rem ifconfig 'interface' local_ip remote_ip 'netmask' my_netmask  /* these two lines came from a slip init script */
rem route 'add default' remote_ip '1'

big_string = '"slattach -p' com_port 'AT&F*F4S0=1 OK"' com_port "57600" local_ip || ':' || remote_ip 'modem netmask' my_netmask ' rtscts silent idle 1440';

ppp "connect" big_string
